# (C) 2018 Svetlana Tkachenko svetlana@members.fsf.org
#
#    This file is part of WAB, Welcome-a-bit for Wikinews.
#
#    WAB is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    WAB is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with WAB.  If not, see <https://www.gnu.org/licenses/>.

package wabget;


use strict;
use warnings;
use MediaWiki::API;
use Data::Dumper;
use XML::Feed;

use wabts;
use wabdeliver;

my $mw = MediaWiki::API->new();


sub _my_process_cat{
	my $self = shift;
    my $hr = shift; #hash ref
    
    my $wikiURL = $hr->{wikiURL};
    $mw->{config}->{api_url} = "$wikiURL/w/api.php";
    my $cat = $hr->{cat};
    my $articleType = $hr->{articleType};
    
    # Get the timestamp of the latest entry in the category
		# https://www.mediawiki.org/wiki/API:Categorymembers      
		# this does not do category overlap ('Physics|Developing') ... :-(    
		#    print Dumper $cat;
		#    my $category_one_entry_ref = $mw->api ( {
		#        action  => 'query',
		#        list    => 'categorymembers',
		#        cmtitle => "Category:$cat",
		#        cmprop  => 'timestamp|title',
		#        cmsort  => 'timestamp',
		#        cmdir   => 'desc',
		#        cmlimit => 0
		#    });
		#    # Get the timestamp of the latest entry delivered to the user
		#    # 2019-02-07T15:50:55Z
		#    my $ts = $category_one_entry_ref->{query}->{categorymembers}->[0]->{timestamp};
		#    my $tsEpoch = wabts->parseTsFromCatMembers($ts);
		#    print "..\r\n";
	# Get it from the RSS feed
	# https://en.wikinews.org/w/index.php?title=Special:NewsFeed&feed=atom&categories=Published&notcategories=No%20publish%7CArchived%7CAutoArchived%7Cdisputed&namespace=0&count=30&hourcount=124&ordermethod=categoryadd&stablepages=only
	my $cats = "$cat";
	if($articleType eq 'dev') {$cats = "$cat|Developing";}
	elsif($articleType eq 'pub') {$cats = "$cat|Published";}
    # my $feedUrl = "$wikiURL/w/index.php?title=Special:NewsFeed&feed=atom&categories=$cats&namespace=0&count=30&hourcount=124&ordermethod=categoryadd&stablepages=include";
    my $feedUrl = "$wikiURL/w/index.php?title=Special:NewsFeed&feed=rss&categories=$cats&namespace=0&count=60&hourcount=99924&ordermethod=categoryadd&stablepages=include";
    print "***Checking title***\r\n";
    my $feed = XML::Feed->parse(URI->new($feedUrl)) or die XML::Feed->errstr;
    print "Feed title: '", $feed->title, "'.\n";
    print "Feed URL: ", $feedUrl, " .\n";
    print "**** checking entries\r\n*";
    
    my $tsEpoch = 0;
    my @feedEntries = ();
    for my $entry ($feed->entries) {
#		print "**** entry*\r\n";
#		print Dumper $entry->{entry}->{pubDate};
		if($tsEpoch == 0){
		    $tsEpoch = wabts->parseTsFromAtomFeed($entry->{entry}->{pubDate});
		}
		push @feedEntries, { 
			'dt' => $entry->{entry}->{pubDate},
			'title' => $entry->{entry}->{title}
		};
    }
    if ($tsEpoch > 0){
		# Compare the time stamps
		my $userTs = $hr->{userTs};
		print "... $cat - checking for time stamps! \r\n";
		if($userTs < $tsEpoch){ # A fresh message is available
			print "need to notify user! their time stamp is outdated!";
			print Dumper \@feedEntries;
			print "\r\n - printed.\r\n";
			$hr->{entries} = \@feedEntries;
			#print $hr->{entries};
			print "\r\n - printed v2.";
			wabdeliver->_notify_user($hr);
		}
}
}

1;

#_ _END_ _
